## avro-c 1.8.2

=== CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#
cmake_minimum_required(VERSION 2.4)
project(AvroC)
enable_testing()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

# Eliminates warning about linker paths when linking both zlib and
# liblzma.
cmake_policy(SET CMP0003 NEW)

#-----------------------------------------------------------------------
# Retrieve the current version number

if (UNIX)
    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh project
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE AVRO_VERSION_RESULT
        OUTPUT_VARIABLE AVRO_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(AVRO_VERSION_RESULT)
        message(FATAL_ERROR "Cannot determine Avro version number")
    endif(AVRO_VERSION_RESULT)

    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh libtool
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        RESULT_VARIABLE LIBAVRO_VERSION_RESULT
        OUTPUT_VARIABLE LIBAVRO_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(LIBAVRO_VERSION_RESULT)
        message(FATAL_ERROR "Cannot determine libavro version number")
    endif(LIBAVRO_VERSION_RESULT)
else(UNIX)
    # Hard code for win32 -- need to figure out how to port version.sh for
    # Windows.
    set(LIBAVRO_VERSION "22:0:0")
endif(UNIX)


#-----------------------------------------------------------------------
# Extract major.minor.patch from version number

if (UNIX)
    string(REGEX REPLACE "([0-9]+)\\..*"
        "\\1"
        AVRO_MAJOR_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\.([0-9]+)\\..*"
        "\\1"
        AVRO_MINOR_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\..*\\.([0-9]+).*"
        "\\1"
        AVRO_PATCH_VERSION
        ${AVRO_VERSION}
    )
    string(REGEX REPLACE ".*\\..*\\.[0-9]+(.*)"
        "\\1"
        AVRO_VERSION_EXTENSION
        ${AVRO_VERSION}
    )
endif(UNIX)

#-----------------------------------------------------------------------
# Source package support

include(CPackConfig.txt)
include(CheckLibraryExists)


if(APPLE)
    if (NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    endif (NOT CMAKE_INSTALL_NAME_DIR)
endif(APPLE)

if(CMAKE_COMPILER_IS_GNUCC)
    add_definitions(-W -Wall)
endif(CMAKE_COMPILER_IS_GNUCC)

if (WIN32)
   # Compile win32 in C++ to allow declarations after statements
   add_definitions(/TP)
endif(WIN32)

# Uncomment to allow missing fields in the resolved-writer
# add_definitions(-DAVRO_ALLOW_MISSING_FIELDS_IN_RESOLVED_WRITER)

# Uncomment to allow non-atomic increment/decrement of reference count
# add_definitions(-DAVRO_ALLOW_NON_ATOMIC_REFCOUNT)

# Thread support (only for *nix with pthreads)
set(THREADS_LIBRARIES)
if(UNIX AND THREADSAFE AND CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_THREAD_PREFER_PTHREAD)
    find_package(Threads)

    if(NOT CMAKE_USE_PTHREADS_INIT)
        message(FATAL_ERROR "pthreads not found")
    endif(NOT CMAKE_USE_PTHREADS_INIT)

    add_definitions(-DTHREADSAFE -D_REENTRANT)
    set(THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif(UNIX AND THREADSAFE AND CMAKE_COMPILER_IS_GNUCC)

include_directories(${AvroC_SOURCE_DIR}/src)


# Enable codecs

find_package(ZLIB)
if (ZLIB_FOUND)
    set(ZLIB_PKG zlib)
    add_definitions(-DDEFLATE_CODEC)
    include_directories(${ZLIB_INCLUDE_DIR})
    message("Enabled deflate codec")
else (ZLIB_FOUND)
    set(ZLIB_PKG "")
    set(ZLIB_LIBRARIES "")
    message("Disabled deflate codec. zlib not found.")
endif (ZLIB_FOUND)

find_package(Snappy)
if (SNAPPY_FOUND AND ZLIB_FOUND)  # Snappy borrows crc32 from zlib
    set(SNAPPY_PKG libsnappy)
    add_definitions(-DSNAPPY_CODEC)
    include_directories(${SNAPPY_INCLUDE_DIR})
    message("Enabled snappy codec")
else (SNAPPY_FOUND AND ZLIB_FOUND)
    set(SNAPPY_PKG "")
    set(SNAPPY_LIBRARIES "")
    message("Disabled snappy codec. libsnappy not found or zlib not found.")
endif (SNAPPY_FOUND AND ZLIB_FOUND)

find_package(PkgConfig)
pkg_check_modules(LZMA liblzma)
if (LZMA_FOUND)
    set(LZMA_PKG liblzma)
    add_definitions(-DLZMA_CODEC)
    include_directories(${LZMA_INCLUDE_DIRS})
    link_directories(${LZMA_LIBRARY_DIRS})
    message("Enabled lzma codec")
else (LZMA_FOUND)
    set(LZMA_PKG "")
    set(LZMA_LIBRARIES "")
    message("Disabled lzma codec. liblzma not found.")
endif (LZMA_FOUND)

set(CODEC_LIBRARIES ${ZLIB_LIBRARIES} ${LZMA_LIBRARIES} ${SNAPPY_LIBRARIES})
set(CODEC_PKG "@ZLIB_PKG@ @LZMA_PKG@ @SNAPPY_PKG@")

# Jansson JSON library
pkg_check_modules(JANSSON jansson>=2.3)
if (JANSSON_FOUND)
    set(JANSSON_PKG libjansson)
    include_directories(${JANSSON_INCLUDE_DIR})
    link_directories(${JANSSON_LIBRARY_DIRS})
else (JANSSON_FOUND)
    message(FATAL_ERROR "libjansson >=2.3 not found")
endif (JANSSON_FOUND)


add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(tests)
add_subdirectory(docs)

add_custom_target(pretty
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_SOURCE_DIR}/cmake_pretty.cmake")

=== src/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

set(AVRO_SRC
    allocation.c
    array.c
    avro.h
    avro/allocation.h
    avro/basics.h
    avro/consumer.h
    avro/data.h
    avro/errors.h
    avro/generic.h
    avro/io.h
    avro/legacy.h
    avro/refcount.h
    avro/resolver.h
    avro/schema.h
    avro/value.h
    avro_generic_internal.h
    avro_private.h
    codec.c
    codec.h
    consumer.c
    consume-binary.c
    datafile.c
    datum.c
    datum.h
    datum_equal.c
    datum_read.c
    datum_size.c
    datum_skip.c
    datum_validate.c
    datum_value.c
    datum_write.c
    dump.c
    dump.h
    encoding.h
    encoding_binary.c
    errors.c
    generic.c
    io.c
    map.c
    memoize.c
    resolved-reader.c
    resolved-writer.c
    resolver.c
    schema.c
    schema.h
    schema_equal.c
    st.c
    st.h
    string.c
    value.c
    value-hash.c
    value-json.c
    value-read.c
    value-sizeof.c
    value-write.c
    wrapped-buffer.c
)


source_group(Avro FILES ${AVRO_SRC})

# The version.sh script gives us a SOVERSION that uses colon as a
# separator; we need periods.

string(REPLACE ":" "." LIBAVRO_DOT_VERSION ${LIBAVRO_VERSION})

add_library(avro-static STATIC ${AVRO_SRC})
target_link_libraries(avro-static ${JANSSON_LIBRARIES} ${CODEC_LIBRARIES} ${THREADS_LIBRARIES})
set_target_properties(avro-static PROPERTIES OUTPUT_NAME avro)

if (NOT WIN32)
# TODO: Create Windows DLLs. See http://www.cmake.org/Wiki/BuildingWinDLL
add_library(avro-shared SHARED ${AVRO_SRC})
target_link_libraries(avro-shared ${JANSSON_LIBRARIES} ${CODEC_LIBRARIES} ${THREADS_LIBRARIES})
set_target_properties(avro-shared PROPERTIES
        OUTPUT_NAME avro
        SOVERSION ${LIBAVRO_DOT_VERSION})
endif(NOT WIN32)

install(FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/avro.h
        DESTINATION include)
install(DIRECTORY
        ${CMAKE_CURRENT_SOURCE_DIR}/avro
        DESTINATION include
        FILES_MATCHING PATTERN "*.h")

if (WIN32)
install(TARGETS avro-static
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )
else(WIN32)
install(TARGETS avro-static avro-shared
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
       )
endif(WIN32)

# Install pkg-config file

set(prefix ${CMAKE_INSTALL_PREFIX})
set(VERSION ${AVRO_VERSION})
configure_file(avro-c.pc.in avro-c.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/avro-c.pc
        DESTINATION lib/pkgconfig)

add_executable(avrocat avrocat.c)
target_link_libraries(avrocat avro-static)
install(TARGETS avrocat RUNTIME DESTINATION bin)

add_executable(avroappend avroappend.c)
target_link_libraries(avroappend avro-static)
install(TARGETS avroappend RUNTIME DESTINATION bin)

if (NOT WIN32)
#TODO: Port getopt() to Windows to compile avropipe.c and avromod.c
add_executable(avropipe avropipe.c)
target_link_libraries(avropipe avro-static)
install(TARGETS avropipe RUNTIME DESTINATION bin)

add_executable(avromod avromod.c)
target_link_libraries(avromod avro-static)
install(TARGETS avromod RUNTIME DESTINATION bin)
endif(NOT WIN32)

=== debian/changelog ===
avro-c (1.8.2-1) unstable; urgency=medium

  * Initial release (Closes: #870571)
  * debian/upstream/signing-key.asc: Import from upstream keyring
    https://www-us.apache.org/dist/avro/KEYS
  * src/avro-c.pc.in: Avoid adding useless -L, -I flags to Libs/Cflags
  * src/avro-c.pc.in: Remove "Requires" keyword
  * src/CMakeLists.txt: Install to correct library directory
  * src/CMakeLists.txt: Link utilities against avro-shared, not avro-
    static
  * CMakeLists.txt, src/CMakeLists.txt: Correctly set VERSION, SOVERSION
  * debian/rules: Add --no-parallel to dh_auto_test

 -- Robert Edmonds <edmonds@debian.org>  Sat, 02 Sep 2017 18:55:41 -0400

=== debian/control ===
Source: avro-c
Priority: optional
Maintainer: Robert Edmonds <edmonds@debian.org>
Build-Depends:
 debhelper (>= 10),
 cmake,
 libjansson-dev (>= 2.3),
 liblzma-dev,
 libsnappy-dev,
 pkg-config,
 zlib1g-dev
Standards-Version: 4.1.0
Section: devel
Homepage: http://avro.apache.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/avro-c.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/avro-c.git

Package: libavro-dev
Section: libdevel
Architecture: any
Depends: libavro23 (= ${binary:Version}), ${misc:Depends}
Description: Apache Avro C library headers (avro-c)
 Apache Avro is a data serialization system. Avro provides rich data
 structures; a binary data format; and a container file format, to store
 Avro-encoded data persistently.
 .
 This package provides the "avro-c" implementation of Apache Avro in C.
 The C implementation supports:
 .
  * binary encoding/decoding of all primitive and complex data types
  * storage to an Avro Object Container File
  * schema resolution, promotion and projection
  * validating and non-validating mode for writing Avro data
 .
 The C implementation of Avro lacks RPC support.
 .
 This package contains the development files.

Package: libavro23
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Apache Avro C shared library (avro-c)
 Apache Avro is a data serialization system. Avro provides rich data
 structures; a binary data format; and a container file format, to store
 Avro-encoded data persistently.
 .
 This package provides the "avro-c" implementation of Apache Avro in C.
 The C implementation supports:
 .
  * binary encoding/decoding of all primitive and complex data types
  * storage to an Avro Object Container File
  * schema resolution, promotion and projection
  * validating and non-validating mode for writing Avro data
 .
 The C implementation of Avro lacks RPC support.
 .
 This package contains the shared library.

Package: avro-bin
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Apache Avro C utilities (avro-c)
 Apache Avro is a data serialization system. Avro provides rich data
 structures; a binary data format; and a container file format, to store
 Avro-encoded data persistently.
 .
 This package provides the "avro-c" implementation of Apache Avro in C.
 The C implementation supports:
 .
  * binary encoding/decoding of all primitive and complex data types
  * storage to an Avro Object Container File
  * schema resolution, promotion and projection
  * validating and non-validating mode for writing Avro data
 .
 The C implementation of Avro lacks RPC support.
 .
 This package contains the avro-c command line utilities.

=== debian/watch ===
version=4
opts="pgpmode=auto" http://www-us.apache.org/dist/avro/stable/c/ avro-c-(.+)\.tar\.gz

## avro-c 1.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,16 @@
     if(LIBAVRO_VERSION_RESULT)
         message(FATAL_ERROR "Cannot determine libavro version number")
     endif(LIBAVRO_VERSION_RESULT)
+
+    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version.sh libcurrent
+        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+        RESULT_VARIABLE LIBAVRO_SOVERSION_RESULT
+        OUTPUT_VARIABLE LIBAVRO_SOVERSION
+        OUTPUT_STRIP_TRAILING_WHITESPACE)
+    if(LIBAVRO_SOVERSION_RESULT)
+        message(FATAL_ERROR "Cannot determine libavro version number")
+    endif(LIBAVRO_SOVERSION_RESULT)
+
 else(UNIX)
     # Hard code for win32 -- need to figure out how to port version.sh for
     # Windows.
@@ -131,7 +141,7 @@
 if (ZLIB_FOUND)
     set(ZLIB_PKG zlib)
     add_definitions(-DDEFLATE_CODEC)
-    include_directories(${ZLIB_INCLUDE_DIR})
+    include_directories(${ZLIB_INCLUDE_DIRS})
     message("Enabled deflate codec")
 else (ZLIB_FOUND)
     set(ZLIB_PKG "")
@@ -143,7 +153,7 @@
 if (SNAPPY_FOUND AND ZLIB_FOUND)  # Snappy borrows crc32 from zlib
     set(SNAPPY_PKG libsnappy)
     add_definitions(-DSNAPPY_CODEC)
-    include_directories(${SNAPPY_INCLUDE_DIR})
+    include_directories(${SNAPPY_INCLUDE_DIRS})
     message("Enabled snappy codec")
 else (SNAPPY_FOUND AND ZLIB_FOUND)
     set(SNAPPY_PKG "")
@@ -172,7 +182,7 @@
 pkg_check_modules(JANSSON jansson>=2.3)
 if (JANSSON_FOUND)
     set(JANSSON_PKG libjansson)
-    include_directories(${JANSSON_INCLUDE_DIR})
+    include_directories(${JANSSON_INCLUDE_DIRS})
     link_directories(${JANSSON_LIBRARY_DIRS})
 else (JANSSON_FOUND)
     message(FATAL_ERROR "libjansson >=2.3 not found")

=== docs/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

set (AVRO_DOC_SRC
    index.txt
)

# TODO(dln): Use FindAsciidoc script instead.
message(STATUS "Searching for asciidoc...")
find_program(ASCIIDOC_EXECUTABLE asciidoc)
find_program(SOURCE_HIGHLIGHT_EXECUTABLE source-highlight)

if (ASCIIDOC_EXECUTABLE AND SOURCE_HIGHLIGHT_EXECUTABLE)
    foreach(_file ${AVRO_DOC_SRC})
        get_filename_component(_file_we ${_file} NAME_WE)
        set(_file_path "${CMAKE_CURRENT_SOURCE_DIR}/${_file}")
        set(_html_out "${CMAKE_CURRENT_BINARY_DIR}/${_file_we}.html")
        add_custom_command(
            OUTPUT "${_html_out}"
            COMMAND ${ASCIIDOC_EXECUTABLE}
                -a avro_version=${AVRO_VERSION}
                -a libavro_version=${LIBAVRO_VERSION}
                -a toc
                --unsafe -n -o "${_html_out}" "${_file_path}"
            DEPENDS "${_file_path}"
            COMMENT "asciidoc ${_file}"
        )
        install(FILES "${_html_out}" DESTINATION share/doc/avro-c)
        add_custom_target("${_file_we}_html" ALL echo -n
            DEPENDS "${_file}" "${_html_out}"
        )
        add_custom_target(docs DEPENDS "${_html_out}")
    endforeach(_file)
else(ASCIIDOC_EXECUTABLE AND SOURCE_HIGHLIGHT_EXECUTABLE)
    message(WARNING "asciidoc not found. HTML documentation will *NOT* be built.")
endif(ASCIIDOC_EXECUTABLE AND SOURCE_HIGHLIGHT_EXECUTABLE)

=== examples/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

add_executable(quickstop quickstop.c)
target_link_libraries(quickstop avro-static)

if (WIN32)
    set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/Debug/quickstop.exe)
else (WIN32)
    set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/quickstop)
endif (WIN32)

add_test(quickstop
    ${CMAKE_COMMAND} -E chdir ${AvroC_SOURCE_DIR}/examples
    ${exec_name}
)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
 
 source_group(Avro FILES ${AVRO_SRC})
 
-# The version.sh script gives us a SOVERSION that uses colon as a
+# The version.sh script gives us a VERSION that uses colon as a
 # separator; we need periods.
 
 string(REPLACE ":" "." LIBAVRO_DOT_VERSION ${LIBAVRO_VERSION})
@@ -94,7 +94,8 @@
 target_link_libraries(avro-shared ${JANSSON_LIBRARIES} ${CODEC_LIBRARIES} ${THREADS_LIBRARIES})
 set_target_properties(avro-shared PROPERTIES
         OUTPUT_NAME avro
-        SOVERSION ${LIBAVRO_DOT_VERSION})
+        VERSION ${LIBAVRO_DOT_VERSION}
+        SOVERSION ${LIBAVRO_SOVERSION})
 endif(NOT WIN32)
 
 install(FILES

=== tests/CMakeLists.txt ===
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.
#

macro(add_avro_executable name)
    set(source "${ARGV1}")
    if (NOT source)
        set(source "${name}.c")
    endif (NOT source)
    add_executable(${name} ${source})
    target_link_libraries(${name} avro-static)
endmacro(add_avro_executable)

macro(add_avro_test name)
    add_avro_executable(${name} ${ARGN})
    if (WIN32)
        set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/Debug/${name}.exe)
    else (WIN32)
        set(exec_name ${CMAKE_CURRENT_BINARY_DIR}/${name})
    endif (WIN32)

    add_test(${name}
        ${CMAKE_COMMAND} -E chdir ${AvroC_SOURCE_DIR}/tests
        ${exec_name}
    )
endmacro(add_avro_test)

macro(add_avro_test_checkmem name)
    add_avro_test(${name} ${ARGN})
    if(UNIX)
        find_program(MEMORYCHECK_COMMAND valgrind )
        if(MEMORYCHECK_COMMAND)
            add_test(memcheck_${name}
                ${CMAKE_COMMAND} -E chdir ${AvroC_SOURCE_DIR}/tests
                ${MEMORYCHECK_COMMAND}
                    --log-file=${CMAKE_CURRENT_BINARY_DIR}/memcheck_${name}.log
                    --leak-check=full
                    --show-reachable=yes
                    --error-exitcode=1
                    ${exec_name}
            )
        endif(MEMORYCHECK_COMMAND)
    endif (UNIX)
endmacro(add_avro_test_checkmem)

add_avro_executable(generate_interop_data)
add_avro_executable(performance)
add_avro_executable(test_interop_data)

add_avro_test_checkmem(test_data_structures)
add_avro_test_checkmem(test_avro_schema)
add_avro_test_checkmem(test_avro_schema_names)
add_avro_test_checkmem(test_avro_values)
add_avro_test_checkmem(test_avro_766)
add_avro_test_checkmem(test_avro_968)
add_avro_test_checkmem(test_avro_984)
add_avro_test_checkmem(test_avro_1034)
add_avro_test_checkmem(test_avro_1084)
add_avro_test_checkmem(test_avro_1087)
add_avro_test_checkmem(test_avro_1165)
add_avro_test_checkmem(test_avro_1167)
add_avro_test_checkmem(test_avro_1237)
add_avro_test_checkmem(test_avro_1238)
add_avro_test_checkmem(test_avro_1279)
add_avro_test_checkmem(test_avro_1405)
add_avro_test_checkmem(test_avro_1572)
add_avro_test(test_avro_data) # Skip memory check for datum. Deprecated and has a lot of memory issues
add_avro_test_checkmem(test_refcount)
add_avro_test_checkmem(test_cpp test_cpp.cpp)
add_avro_test_checkmem(test_avro_1379)
add_avro_test_checkmem(test_avro_1691)
add_avro_test_checkmem(test_avro_1906)
add_avro_test_checkmem(test_avro_1904)

=== debian/changelog ===
avro-c (1.9.0-1) unstable; urgency=medium

  * New upstream version 1.9.0
  * debian/control: Update Vcs-Git, Vcs-Browser to salsa.debian.org URLs
  * debian/control: Bump Standards-Version to 4.3.0 (no changes)
  * debian/control: Use HTTPS URL for Homepage
  * debian/watch: Use HTTPS for watch URL
  * debian/docs: Include top-level "NOTICE" file

 -- Robert Edmonds <edmonds@debian.org>  Fri, 28 Jun 2019 18:42:56 -0400

=== debian/control ===
--- 
+++ 
@@ -9,11 +9,11 @@
  libsnappy-dev,
  pkg-config,
  zlib1g-dev
-Standards-Version: 4.1.0
+Standards-Version: 4.3.0
 Section: devel
-Homepage: http://avro.apache.org
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/avro-c.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/avro-c.git
+Homepage: https://avro.apache.org
+Vcs-Git: https://salsa.debian.org/edmonds/avro-c.git
+Vcs-Browser: https://salsa.debian.org/edmonds/avro-c
 
 Package: libavro-dev
 Section: libdevel

=== debian/watch ===
version=4
opts="pgpmode=auto" https://www-us.apache.org/dist/avro/stable/c/ avro-c-(.+)\.tar\.gz

## avro-c 1.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # "License"); you may not use this file except in compliance
 # with the License.  You may obtain a copy of the License at
 #
-#   http://www.apache.org/licenses/LICENSE-2.0
+#   https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing,
 # software distributed under the License is distributed on an
@@ -16,8 +16,8 @@
 # specific language governing permissions and limitations
 # under the License.
 #
-cmake_minimum_required(VERSION 2.4)
-project(AvroC)
+cmake_minimum_required(VERSION 3.1)
+project(AvroC C)
 enable_testing()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR})

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # "License"); you may not use this file except in compliance
 # with the License.  You may obtain a copy of the License at
 #
-#   http://www.apache.org/licenses/LICENSE-2.0
+#   https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing,
 # software distributed under the License is distributed on an
@@ -48,6 +48,6 @@
         add_custom_target(docs DEPENDS "${_html_out}")
     endforeach(_file)
 else(ASCIIDOC_EXECUTABLE AND SOURCE_HIGHLIGHT_EXECUTABLE)
-    message(WARNING "asciidoc not found. HTML documentation will *NOT* be built.")
+    message(WARNING "asciidoc and/or source-highlight not found. HTML documentation will *NOT* be built.")
 endif(ASCIIDOC_EXECUTABLE AND SOURCE_HIGHLIGHT_EXECUTABLE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # "License"); you may not use this file except in compliance
 # with the License.  You may obtain a copy of the License at
 #
-#   http://www.apache.org/licenses/LICENSE-2.0
+#   https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing,
 # software distributed under the License is distributed on an
@@ -89,7 +89,7 @@
 set_target_properties(avro-static PROPERTIES OUTPUT_NAME avro)
 
 if (NOT WIN32)
-# TODO: Create Windows DLLs. See http://www.cmake.org/Wiki/BuildingWinDLL
+# TODO: Create Windows DLLs. See https://www.cmake.org/Wiki/BuildingWinDLL
 add_library(avro-shared SHARED ${AVRO_SRC})
 target_link_libraries(avro-shared ${JANSSON_LIBRARIES} ${CODEC_LIBRARIES} ${THREADS_LIBRARIES})
 set_target_properties(avro-shared PROPERTIES
@@ -106,17 +106,19 @@
         DESTINATION include
         FILES_MATCHING PATTERN "*.h")
 
+include(GNUInstallDirs)
+
 if (WIN32)
 install(TARGETS avro-static
-        RUNTIME DESTINATION bin
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
 else(WIN32)
 install(TARGETS avro-static avro-shared
-        RUNTIME DESTINATION bin
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
+	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        )
 endif(WIN32)
 
@@ -126,7 +128,7 @@
 set(VERSION ${AVRO_VERSION})
 configure_file(avro-c.pc.in avro-c.pc)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/avro-c.pc
-        DESTINATION lib/pkgconfig)
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 add_executable(avrocat avrocat.c)
 target_link_libraries(avrocat avro-static)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # "License"); you may not use this file except in compliance
 # with the License.  You may obtain a copy of the License at
 #
-#   http://www.apache.org/licenses/LICENSE-2.0
+#   https://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing,
 # software distributed under the License is distributed on an
@@ -81,7 +81,6 @@
 add_avro_test_checkmem(test_avro_1572)
 add_avro_test(test_avro_data) # Skip memory check for datum. Deprecated and has a lot of memory issues
 add_avro_test_checkmem(test_refcount)
-add_avro_test_checkmem(test_cpp test_cpp.cpp)
 add_avro_test_checkmem(test_avro_1379)
 add_avro_test_checkmem(test_avro_1691)
 add_avro_test_checkmem(test_avro_1906)

=== debian/changelog ===
avro-c (1.11.1-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:42:32 +0200

avro-c (1.11.1-1) unstable; urgency=medium

  * New upstream version 1.11.1
  * debian/gbp.conf: [DEFAULT] Set default-branch, upstream-branch
  * debian/watch: Update download URL to
    https://dlcdn.apache.org/avro/stable/c/
  * debian/upstream/signing-key.asc: Refresh from
    https://dist.apache.org/repos/dist/release/avro/KEYS
  * debian/patches/0005-CMakeLists.txt-src-CMakeLists.txt-Correctly-set-
    VERS.patch: Remove (applied upstream)
  * debian/patches: Rebase patches
  * debian/patches/0003-src-CMakeLists.txt-Install-to-correct-library-
    direct.patch: Remove (applied upstream)
  * debian/source/lintian-overrides: Add override for source-is-missing
    [docs/index.html]
  * debian/control: Bump Standards-Version to 4.6.2 (no changes)
  * debian/: Bump debhelper compat level from 10 to 13
  * debian/source/patch-header: Remove
  * debian/source/local-options: Remove 'single-debian-patch'
  * debian/control: Remove version constraint for libjansson-dev
    dependency (o-o-stable has 2.9-1)
  * debian/control: Mark libavro23 'Multi-Arch: same'
  * debian/: Install static library into libavro-dev package

 -- Robert Edmonds <edmonds@debian.org>  Wed, 21 Dec 2022 17:39:31 -0500

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: avro-c
 Priority: optional
-Maintainer: Robert Edmonds <edmonds@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Robert Edmonds <edmonds@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 13),
  cmake,
- libjansson-dev (>= 2.3),
+ libjansson-dev,
  liblzma-dev,
  libsnappy-dev,
  pkg-config,
  zlib1g-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.6.2
 Section: devel
 Homepage: https://avro.apache.org
 Vcs-Git: https://salsa.debian.org/edmonds/avro-c.git
@@ -19,7 +20,7 @@
 Section: libdevel
 Architecture: any
 Depends: libavro23 (= ${binary:Version}), ${misc:Depends}
-Description: Apache Avro C library headers (avro-c)
+Description: Apache Avro C static library and headers (avro-c)
  Apache Avro is a data serialization system. Avro provides rich data
  structures; a binary data format; and a container file format, to store
  Avro-encoded data persistently.
@@ -39,6 +40,7 @@
 Package: libavro23
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Apache Avro C shared library (avro-c)
  Apache Avro is a data serialization system. Avro provides rich data

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_test:
	dh_auto_test --no-parallel

override_dh_installchangelogs:
	dh_installchangelogs -XChangeLog

=== debian/watch ===
version=4
opts="pgpmode=auto" https://dlcdn.apache.org/avro/stable/c/ avro-c-(.+)\.tar\.gz

## avro-c 1.12.0

=== debian/changelog ===
avro-c (1.12.0-3) unstable; urgency=medium

  * Add autopkgtest that runs test suite from upstream.
  * d/control: add myself in uploaders.

 -- Shengqi Chen <harry@debian.org>  Thu, 20 Feb 2025 20:24:55 +0800

avro-c (1.12.0-2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/patches: import patch to fix memory alignment issues
    (closes: #881740)

 -- Shengqi Chen <harry@debian.org>  Thu, 20 Feb 2025 15:28:46 +0800

avro-c (1.12.0-1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable. 

 -- Shengqi Chen <harry@debian.org>  Tue, 18 Feb 2025 22:26:49 +0800

avro-c (1.12.0-1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Add symbol control file for libavro23 @ 1.11.1
  * New upstream version 1.12.0 (closes: #1074832, #1095941)
    + bump SONAME to libavro24
  * d/patches:
    + refresh existing patches, add DEP-3 metadata to patches
    + add a patch to disable a flaky test due to missing file
  * d/{control, rules}: use ninja as cmake backend
  * d/control:
    + replace obsolete B-D name (pkg-config -> pkgconf)
    + bump std-ver to 4.7.0 (no changes required)
    + add Multi-Arch: same to libavro-dev
    + change vcs address due to repo move

 -- Shengqi Chen <harry@debian.org>  Sun, 16 Feb 2025 21:08:09 +0800

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,27 @@
 Source: avro-c
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Robert Edmonds <edmonds@debian.org>
+Maintainer: Robert Edmonds <edmonds@debian.org>
+Uploaders: Shengqi Chen <harry@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
+ ninja-build,
  libjansson-dev,
  liblzma-dev,
  libsnappy-dev,
- pkg-config,
+ pkgconf,
  zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: devel
 Homepage: https://avro.apache.org
-Vcs-Git: https://salsa.debian.org/edmonds/avro-c.git
-Vcs-Browser: https://salsa.debian.org/edmonds/avro-c
+Vcs-Git: https://salsa.debian.org/debian/avro-c.git
+Vcs-Browser: https://salsa.debian.org/debian/avro-c
 
 Package: libavro-dev
 Section: libdevel
 Architecture: any
-Depends: libavro23 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libavro24 (= ${binary:Version}), ${misc:Depends}
 Description: Apache Avro C static library and headers (avro-c)
  Apache Avro is a data serialization system. Avro provides rich data
  structures; a binary data format; and a container file format, to store
@@ -37,7 +39,7 @@
  .
  This package contains the development files.
 
-Package: libavro23
+Package: libavro24
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake+ninja
 
 override_dh_auto_test:
 	dh_auto_test --no-parallel

=== debian/tests/control ===
Tests: upstream-test-suite
Restrictions: allow-stderr
Depends: @, build-essential, pkgconf, cmake, ninja-build,
         valgrind [amd64 arm64 armhf i386 mips64el ppc64 ppc64el s390x]
